#include <WiFi.h>
#include <esp_now.h>
#include <DHT.h>
#include <SPI.h>
#include <PCA9557.h>
#include <lvgl.h>
#include "ui.h"
#include "gfx_conf.h"
#include <WiFi.h>
#include <Arduino.h>
#include "ui_events.c"
#include <esp_now.h>
#include "esp_system.h"
#include "esp_sntp.h"
#include "driver/rtc_io.h"

#define DHTPin 5
#define DHTType DHT22

DHT dht(DHTPin, DHTType);

float temp;
float humid;
int y;
int x;
int xval;
int yval;
int Slider1;
int Slider2;
int Value_SelectC;
int Value_SelectCsharp;
int Value_SelectA;
int Value_SelectB;  
int Value_SelectBb;
int Value_SelectD;
int Value_SelectFb;
int Value_SelectE;
int Value_SelectFsharp;
int Value_SelectG;
int Slider_LUP;  
int Slider_LL; 
int Slider_LR;
int Slider_RR; 
int Slider_RL;
int Value_AutoAdjust;
int Value_StringUP;
int Value_StringDOWN;
int Value_String1;
int Value_String2;
int Value_String3;  
int Value_String4;
int Value_String5;
int Value_String6;
int Value_String7;
int Value_String8;
int Value_String9;
int Value_String10;
int Value_String11;
int Value_String12;

uint8_t broadcastAddress[] = {0x24, 0xdc, 0xc3, 0xa0, 0x40, 0x74};//RGB Chord Selecct
//uint8_t broadcastAddress2[] = {0xc8, 0xf0, 0x9e, 0x64, 0xb3, 0x4d}; //Tuning String/AutoTune
uint8_t broadcastAddress2[] = {0xc8, 0xf0, 0x9e, 0x64, 0xb3, 0x4c}; //Stepper / Calibrate Foot/Knee
uint8_t broadcastAddress3[] = {0xC0, 0x49, 0xEF, 0xD0, 0x41, 0xBC}; 

esp_now_peer_info_t peerInfo;

void OnDataSent(const uint8_t *macAddr, esp_now_send_status_t status)
{
  Serial.print("Last Packet Send Status: ");
  Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
  myData1.Slider1 = lv_slider_get_value(ui_Slider1);
  myData1.Slider2 = lv_slider_get_value(ui_Slider2);
  //Serial.print(ui_event_BTN_DOWN);

}
static lv_disp_draw_buf_t draw_buf;
static lv_color_t disp_draw_buf1[screenWidth * screenHeight / 8];
static lv_color_t disp_draw_buf2[screenWidth * screenHeight / 8];
static lv_disp_drv_t disp_drv;

PCA9557 Out; 

void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p) {
    uint32_t w = (area->x2 - area->x1 + 1);
    uint32_t h = (area->y2 - area->y1 + 1);

    tft.pushImageDMA(area->x1, area->y1, w, h, (lgfx::rgb565_t*)&color_p->full);
    lv_disp_flush_ready(disp);
}

void my_touchpad_read(lv_indev_drv_t *indev_driver, lv_indev_data_t *data) {
    uint16_t touchX, touchY;
    bool touched = tft.getTouch(&touchX, &touchY);
    if (!touched) {
        data->state = LV_INDEV_STATE_REL;
    } else {
        data->state = LV_INDEV_STATE_PR;
        data->point.x = touchX;
        data->point.y = touchY;
    }
}

void setup() {
 
  Serial.begin(9600);

  dht.begin();

  WiFi.mode(WIFI_STA);

  if (esp_now_init() != 0) {
    return;
  }
  esp_now_register_send_cb(OnDataSent);

  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;
  peerInfo.encrypt = false;

  if (esp_now_add_peer(&peerInfo) != ESP_OK) {
    return;
  }
  memcpy(peerInfo.peer_addr, broadcastAddress2, 6);
  peerInfo.channel = 0;
  peerInfo.encrypt = false;

  if (esp_now_add_peer(&peerInfo) != ESP_OK) {
    return;
  }

  memcpy(peerInfo.peer_addr, broadcastAddress3, 6);
  peerInfo.channel = 0;
  peerInfo.encrypt = false;

  if (esp_now_add_peer(&peerInfo) != ESP_OK) {
    return;
  }


  tft.begin();
  tft.setRotation(1);
  tft.fillScreen(TFT_BLACK);
  tft.setTextSize(2);
  delay(200);

  lv_init();
  delay(100);

  lv_disp_draw_buf_init(&draw_buf, disp_draw_buf1, disp_draw_buf2, screenWidth * screenHeight / 8);
  lv_disp_drv_init(&disp_drv);
  disp_drv.hor_res = screenHeight;
  disp_drv.ver_res = screenWidth;
  disp_drv.flush_cb = my_disp_flush;
  disp_drv.full_refresh = 1;
  disp_drv.draw_buf = &draw_buf;
  lv_disp_drv_register(&disp_drv);

  static lv_indev_drv_t indev_drv;
  lv_indev_drv_init(&indev_drv);
  indev_drv.type = LV_INDEV_TYPE_POINTER;
  indev_drv.read_cb = my_touchpad_read;
  lv_indev_drv_register(&indev_drv);

  tft.fillScreen(TFT_BLACK);

  ui_init(); // UI function that comes from ui.c
}

void loop() {
  char buf[16];
  lv_timer_handler();
  delay(5);

  xval = random(0, 20);
  yval = random(0, 20);
  myData1.x = xval;
  myData1.y = yval;

  // Send data to first address
  esp_now_send(broadcastAddress, (uint8_t *)&myData1, sizeof(myData1));
  
  // Send data to second address
  esp_now_send(broadcastAddress2, (uint8_t *)&myData1, sizeof(myData1));

    // Send data to second address
  esp_now_send(broadcastAddress3, (uint8_t *)&myData1, sizeof(myData1));

  int Slider_LUP = (int)lv_slider_get_value(ui_Slider_LUP);
  lv_snprintf(buf, sizeof(buf), "LUP: %d", Slider_LUP);
  lv_label_set_text(ui_A2, buf);

  int Slider_RR = (int)lv_slider_get_value(ui_Slider_RR);
  lv_snprintf(buf, sizeof(buf), "RR: %d", Slider_RR);
  lv_label_set_text(ui_A1, buf);

  int Slider_RL = (int)lv_slider_get_value(ui_Slider_RL);
  lv_snprintf(buf, sizeof(buf), "RL: %d", Slider_RL);
  lv_label_set_text(ui_A3, buf);

  int Slider_LR = (int)lv_slider_get_value(ui_Slider_LR);
  lv_snprintf(buf, sizeof(buf), "LR: %d", Slider_LR);
  lv_label_set_text(ui_A4, buf);

  int Slider_LL = (int)lv_slider_get_value(ui_Slider_LL);
  lv_snprintf(buf, sizeof(buf), "LL: %d", Slider_LL);
  lv_label_set_text(ui_A5, buf);

  // Delay for DHT22 sensor
  delay(100);
}